﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Stimulsoft.Report;

namespace StimulsoftWpfApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public int NumberOfColumn;
        public MainWindow()
        {
            InitializeComponent();
            NumberOfColumn = 0;
            FillData();
        }

        private List<Client> Clients = new List<Client>();

        private void FillData()
        {
            Client c1 = new Client(1, "Jessica");
            Client c2 = new Client(2, "Rachel");
            Client c3 = new Client(3, "Megan");

            List<Quality> l1 = new List<Quality>();
            l1.Add(new Quality(1, new Product("A"), 1));
            l1.Add(new Quality(2, new Product("B"), 2));
            l1.Add(new Quality(3, new Product("C"), 3));
            c1.Qualities = l1;

            List<Quality> l2 = new List<Quality>();
            l2.Add(new Quality(1, new Product("A"), 1));
            l2.Add(new Quality(3, new Product("B"), 2));
            l2.Add(new Quality(5, new Product("C"), 3));
            c2.Qualities = l2;

            List<Quality> l3 = new List<Quality>();
            l3.Add(new Quality(2, new Product("A"), 1));
            l3.Add(new Quality(4, new Product("B"), 2));
            l3.Add(new Quality(8, new Product("C"), 3));
            c3.Qualities = l3;

            Clients.Add(c1);
            Clients.Add(c2);
            Clients.Add(c3);

            NumberOfColumn = 3;
        }

        private void butDesign_Click(object sender, RoutedEventArgs e)
        {
            StiReport r = new StiReport();
            //r.Load("..\\..\\Report.mrt");
            r.Load("..\\..\\Report_modified.mrt");

            r.RegBusinessObject("Clients", Clients);

            r.DesignWithWpf();
        }

        private void butShow_Click(object sender, RoutedEventArgs e)
        {
            StiReport r = new StiReport();
            //r.Load("..\\..\\Report.mrt");
            r.Load("..\\..\\Report_modified.mrt");

            r.RegBusinessObject("Clients", Clients);
                        
            r.ShowWithWpf();
        }

        private void butAdd_Click(object sender, RoutedEventArgs e)
        {
            string name = tbName.Text;
            Product product = new Product(name);
            NumberOfColumn += 1;

            int value = 0;
            string valueJessica = tbValueJessica.Text;
            Int32.TryParse(valueJessica, out value);
            Quality qualityJessica = new Quality(value, product, NumberOfColumn);
            Clients.First(c => c.Name == "Jessica").Qualities.Add(qualityJessica);

            value = 0;
            string valueRachel = tbValueRachel.Text;
            Int32.TryParse(valueRachel, out value);
            Quality qualityRachel = new Quality(value, product, NumberOfColumn);
            Clients.First(c => c.Name == "Rachel").Qualities.Add(qualityRachel);

            value = 0;
            string valueMegan = tbValueMegan.Text;
            Int32.TryParse(valueMegan, out value);
            Quality qualityMegan = new Quality(value, product, NumberOfColumn);
            Clients.First(c => c.Name == "Megan").Qualities.Add(qualityMegan);

            MessageBox.Show("Column has been added.");

            tbName.Text = string.Empty;
            tbValueJessica.Text = string.Empty;
            tbValueRachel.Text = string.Empty;
            tbValueMegan.Text = string.Empty;
        }
    }
}
